(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "../Utils", "./insertionSort"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    const Utils_1 = require("../Utils");
    const insertionSort_1 = require("./insertionSort");
    function quickSort(array, comparator = Utils_1.Utils.gt, leftIndex = 0, rightIndex = -1) {
        if (!Array.isArray(array) || array.length < 2) {
            return array;
        }
        if (rightIndex === -1) {
            rightIndex = array.length - 1;
        }
        if (leftIndex >= rightIndex) {
            return array;
        }
        if (leftIndex > rightIndex - 10) {
            return insertionSort_1.default(array, comparator, leftIndex, rightIndex + 1);
        }
        const pivot = partition(array, comparator, leftIndex, rightIndex);
        quickSort(array, comparator, leftIndex, pivot - 1);
        return quickSort(array, comparator, pivot + 1, rightIndex);
    }
    function partition(array, comparator, leftIndex, rightIndex) {
        const pivotIndex = leftIndex + Math.floor(Math.random() * (rightIndex - leftIndex));
        Utils_1.Utils.swapValues(array, rightIndex, pivotIndex);
        const pivot = array[rightIndex];
        let border = leftIndex - 1;
        for (let j = leftIndex; j < rightIndex; j++) {
            if (!comparator(array[j], pivot)) {
                border++;
                Utils_1.Utils.swapValues(array, j, border);
            }
        }
        Utils_1.Utils.swapValues(array, border + 1, rightIndex);
        return border + 1;
    }
    exports.default = quickSort;
});
//# sourceMappingURL=quickSort.js.map