(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "../Utils"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    const Utils_1 = require("../Utils");
    function selectionSort(array, comparator = Utils_1.Utils.gt) {
        if (!Array.isArray(array) || array.length < 2) {
            return array;
        }
        let position = 0;
        const arraySize = array.length;
        while (position < arraySize) {
            const lowestIndex = Utils_1.Utils.minIndex(array, position, arraySize, comparator);
            Utils_1.Utils.swapValues(array, position, lowestIndex);
            position++;
        }
        return array;
    }
    exports.default = selectionSort;
});
//# sourceMappingURL=selectionSort.js.map